//`[W|vH + Low Pass FilterH
//Revised on 01:48 05/11/22
//pd1p, pd1n, fdp, fdn, vout :: signed-integer, 4bit-over + 20bit-core

module cp_lpf(rst, pd1p, pd1n, fdp, fdn, vout, vdd, vss);
	input rst;
	input pd1p, pd1n, fdp, fdn;
	input vdd, vss;
	output [23:0] vout;
	reg rst_rk;//QNb^vZ̏tOB
	reg cal_rk;//QNb^vZ̗LtOB
	reg good_err=1'b0;//QNb^vZŃG[\ۂ̃tOB
	reg tmp1b_1;
	reg [23:0] vout;
	reg [31:0] thrs1_32b, thrs2_32b, tmp32b_1, tmp32b_lmtH, tmp32b_lmtL;

	integer cycle;//QNb^̎spx̋tB
	integer h_n, h_n0;//QNb^vZł̃XLbvAXLbv̏lB
	integer cnt_dwn_rk;//QNb^vZɂXLbṽJE^B
	integer hit_min_h;//QNb^vZɂŏԍ݂̎gppxiCPo͍XVjB
	integer tmp_i1, tmp_i2;
	real ip_pd1, in_pd1, ip_fd, im_fd, in_fd;
	real i_pd1, i_fd;
	real rl_iin, a11, a12, a21, a22, b1;
	real rl_b1_iin, rl_x1, rl_x2, k1a, k1b, k2a, k2b, k3a, k3b;
	real dif_x1, dif_x2, err_x1, err_x2;
	real rl_relerr, rl_abserr;
	real tmp_r1, tmp_r2, tmp_r3, tmp_r4;

	parameter TM_PRCS=0.001;//[nsec]AԒPʁB
	parameter K_RTOI=524288.0;//lƓvZplƕϊ䗦B 2^20ɑ΂Ď2.0ΉB
	parameter CUR_CP_PD1=5.0;//[uA]AʑoiPDjɊւ[ddlB̓Iɂ͐dlB
	parameter RTO_B_A_PD1=1.0;//o͓dl̐o͓dlɑ΂iPDjB
	parameter CUR_CP_FD=5.0;//[uA]AgoiFDjɊւ[ddlB̓Iɂ͐dlB
	parameter RTO_B_A_FD=1.0;//o͓dl̐o͓dlɑ΂iFDjB
	parameter OFS_CUR_CP_FD=0.0;//[uA]AgoiFDjɊւ钆ԃxdlB
	parameter CP=8.0;//[pF]ALPFł̃LpV^lB
	parameter C2=0.2;//[pF]ALPFł̃LpV^liNbNEtB[hX[}pjB
	parameter RP=1000.0;//[Ohm]ALPFł̒RlB
	parameter TS_RK=0.001;//[nsec]AQNb^̎B
	parameter N_STP_INI=0.1;//[nsec]AQNb^vZ̃Xebv̏liLPFo͂̍XVjB
	parameter RELERR=0.001;//e΃G[B
	parameter ABSERR=0.00001;//e΃G[B
	
	initial begin
		rl_relerr=RELERR;
		rl_abserr=ABSERR;
		rst_rk=1'b1;//TCÑZbgB
		hit_min_h=0;//ŏԍ݂̎gppxOɃZbgB

		tmp_r1=TS_RK/TM_PRCS;
		tmp_i1=tmp_r1;
		cycle=(tmp_i1 < 1)? 1:tmp_i1;
		tmp_r2=cycle;
		a11=-(TM_PRCS*1000.0*tmp_r2)/(C2*RP);
		a12=-a11;
		a21=(TM_PRCS*1000.0*tmp_r2)/(CP*RP);
		a22=-a21;
		b1=(TM_PRCS*1000.0*tmp_r2)/C2;

		tmp_r1=cycle;
		tmp_r2=(N_STP_INI/(TM_PRCS*cycle));
		tmp_i1=tmp_r2;
		h_n0=(tmp_i1 < 1)? 1:tmp_i1;

		ip_pd1=CUR_CP_PD1*0.000001;//[A]APDɂ鐳o͓dlB
		in_pd1=-RTO_B_A_PD1*CUR_CP_PD1*0.000001;//[A]APDɂ镉o͓dlB
		ip_fd=CUR_CP_FD*0.000001;//[A]AFDɂ鐳o͓dlB
		in_fd=-RTO_B_A_FD*CUR_CP_FD*0.000001;//[A]AFDɂ镉o͓dlB
		im_fd=OFS_CUR_CP_FD*0.000001;//[A]AFDɂ钆ԃxo͓dliz͗jB
		rl_x1=0;
		rl_x2=0;

		tmp32b_lmtH={8'h00, 24'h7F_FFFF};
		tmp32b_lmtL=~tmp32b_lmtH;
	end

	//`[W|v
	always @ (pd1p or fdp) begin
		if(pd1p==1'b1) i_pd1=ip_pd1;
		else i_pd1=in_pd1;

		if((fdp==1'b1) &(fdn==1'b0)) i_fd=ip_fd;
		else if((fdp==1'b0) &(fdn==1'b1)) i_fd=in_fd;
		else i_fd=im_fd;

		//QNb^p
		rl_iin=i_pd1-i_fd;
		rl_b1_iin=b1*rl_iin;
		rst_rk <= 1'b1;
	end

	//Low Pass Filter
	always #(cycle) begin
		if(rst==1'b1) begin
			rl_x1=0;
			rl_x2=0;

			//QNb^p
			rl_b1_iin=0.0;
			rst_rk <= 1'b1;
			h_n=h_n0;
		end else begin
		//QNb^F 23̖ߍݎ
			if(rst_rk==1'b1) begin
				tmp_i1=h_n-cnt_dwn_rk;
				tmp_i2=(tmp_i1 < 1)? 1: tmp_i1;
				tmp_r1=h_n;
				tmp_r2=tmp_i2;
				tmp_r3=tmp_r2/tmp_r1;
				rl_x1 = rl_x1 +tmp_r3*k2a;//Ԓl̍XVB
				rl_x2 = rl_x2 +tmp_r3*k2b;//Ԓl̍XVB

				h_n=h_n0;
				cnt_dwn_rk=h_n0;
				cal_rk=1'b1;
			end else begin
				if(cnt_dwn_rk==0) begin
					rl_x1 = rl_x1 +k2a;//Ԓl̍XVB
					rl_x2 = rl_x2 +k2b;//Ԓl̍XVB

					h_n = (h_n << 2);
					cnt_dwn_rk=h_n;
					cal_rk=1'b1;
				end else
					cal_rk=1'b0;
			end

			if(cal_rk==1'b1) begin 
				while (cal_rk==1'b1) begin
				//QNb^vZ̃RAB
					tmp_r3=h_n;
					k1a=(a11*rl_x1 +a12*rl_x2 +rl_b1_iin)*tmp_r3;
					k1b=(a21*rl_x1 +a22*rl_x2)*tmp_r3;

					tmp_r1=rl_x1 +k1a*0.5;
					tmp_r2=rl_x2 +k1b*0.5;
					k2a=(a11*tmp_r1 +a12*tmp_r2 +rl_b1_iin)*tmp_r3;
					k2b=(a21*tmp_r1 +a22*tmp_r2)*tmp_r3;

					tmp_r1=rl_x1 -k1a +k2a*2;
					tmp_r2=rl_x2 -k1b +k2b*2;
					k3a=(a11*tmp_r1 +a12*tmp_r2 +rl_b1_iin)*tmp_r3;
					k3b=(a21*tmp_r1 +a22*tmp_r2)*tmp_r3;

					dif_x1=(-k1a +k2a*2.0 -k3a)/6.0;
					dif_x2=(-k1b +k2b*2.0 -k3b)/6.0;
					tmp_r3 = rl_x1 +(k1a +k2a*4 +k3a)/6.0;
					tmp_r4 = rl_x2 +(k1b +k2b*4 +k3b)/6.0;

					tmp_r1=(tmp_r3 > 0)? tmp_r3:-tmp_r3;
					tmp_r2=(tmp_r4 > 0)? tmp_r4:-tmp_r4;
					err_x1=tmp_r1*rl_relerr + rl_abserr;
					err_x2=tmp_r2*rl_relerr + rl_abserr;
					tmp_r1=(dif_x1 > 0)? dif_x1:-dif_x1;
					tmp_r2=(dif_x2 > 0)? dif_x2:-dif_x2;

					good_err=((err_x1 >= tmp_r1) && (err_x2 >= tmp_r2))? 1'b1:1'b0;
					if((good_err==1'b1) || (h_n==1)) begin
						rst_rk <= 1'b0;//B
						cal_rk = 1'b0;//QNb^vZ[voB
					end else begin
						tmp_i1 = h_n >> 2;
						h_n=(tmp_i1 < 1)? 1: tmp_i1;
						hit_min_h=(tmp_i1 < 1)? (hit_min_h+1) : hit_min_h;
						cnt_dwn_rk=h_n;
					end
				end
			end
			cnt_dwn_rk=cnt_dwn_rk-1;//_EJE^̃fNgB
		end

		tmp_r3=rl_x1*K_RTOI;
		tmp32b_1=$rtoi(tmp_r3);
		if(tmp32b_1[31]==1'b0) 
			vout <= (tmp32b_1 > tmp32b_lmtH)? tmp32b_lmtH[23:0] : tmp32b_1[23:0];//~b^B
		else
			vout <= (tmp32b_1 < tmp32b_lmtL)? tmp32b_lmtL[23:0] : tmp32b_1 [23:0];//~b^B
	end

endmodule
