//`[W|vH + Low Pass FilterH
//Revised on 01:48 05/11/22
//pd1p, pd1n, fdp, fdn, vout :: signed-integer, 4bit-over + 20bit-core
`timescale 1ps/1ps
module cp_lpf(rst, pd1p, pd1n, fdp, fdn, vout, vdd, vss);
	input rst;
	input pd1p, pd1n, fdp, fdn;
	input vdd, vss;
	output [23:0] vout;
	reg rst_rk,rst_rk_BK;//QNb^vZ̏tOB
	reg cal_rk;//QNb^vZ̗LtOB
	reg good_err=1'b0;//QNb^vZŃG[\ۂ̃tOB
	reg tmp1b_1;
	reg [23:0] vout,vout_BK;
	reg [31:0] thrs1_32b, thrs2_32b, tmp32b_1, tmp32b_lmtH, tmp32b_lmtL;

	integer cycle;//QNb^̎spx̋tB
	integer h_n, h_n0;//QNb^vZł̃XLbvAXLbv̏lB
	integer cnt_dwn_rk;//QNb^vZɂXLbṽJE^B
	integer hit_min_h;//QNb^vZɂŏԍ݂̎gppxiCPo͍XVjB
	integer tmp_i1, tmp_i2;
	real ip_pd1, in_pd1, ip_fd, im_fd, in_fd;
	real i_pd1, i_fd;
	real rl_iin, a11, a12, a21, a22, b1;
	real rl_b1_iin, rl_x1, rl_x2, k1a, k1b, k2a, k2b, k3a, k3b;
	real dif_x1, dif_x2, err_x1, err_x2;
	real rl_relerr, rl_abserr;
	real tmp_r1, tmp_r2, tmp_r3, tmp_r4;
	real K_RTOI_val;

	parameter TM_PRCS=0.001;//[nsec]AԒPʁB
	parameter K_RTOI=524288.0;//lƓvZplƕϊ䗦B 2^20ɑ΂Ď2.0ΉB
	parameter CUR_CP_PD1=5.0;//[uA]AʑoiPDjɊւ[ddlB̓Iɂ͐dlB
	parameter RTO_B_A_PD1=1.0;//o͓dl̐o͓dlɑ΂iPDjB
	parameter CUR_CP_FD=5.0;//[uA]AgoiFDjɊւ[ddlB̓Iɂ͐dlB
	parameter RTO_B_A_FD=1.0;//o͓dl̐o͓dlɑ΂iFDjB
	parameter OFS_CUR_CP_FD=0.0;//[uA]AgoiFDjɊւ钆ԃxdlB
	parameter CP=8.0;//[pF]ALPFł̃LpV^lB
	parameter C2=0.2;//[pF]ALPFł̃LpV^liNbNEtB[hX[}pjB
	parameter RP=1000.0;//[Ohm]ALPFł̒RlB
	parameter TS_RK=0.001;//[nsec]AQNb^̎B
	parameter N_STP_INI=0.1;//[nsec]AQNb^vZ̃Xebv̏liLPFo͂̍XVjB
	parameter RELERR=0.001;//e΃G[B
	parameter ABSERR=0.00001;//e΃G[B
	
	initial begin
		rl_relerr=RELERR;
		rl_abserr=ABSERR;
		rst_rk=1'b1;//TCÑZbgB
		hit_min_h=0;//ŏԍ݂̎gppxOɃZbgB

		tmp_r1=TS_RK/TM_PRCS;
		tmp_i1=tmp_r1;
		cycle=(tmp_i1 < 1)? 1:tmp_i1;
		tmp_r2=cycle;
		a11=-(TM_PRCS*1000.0*tmp_r2)/(C2*RP);
		a12=-a11;
		a21=(TM_PRCS*1000.0*tmp_r2)/(CP*RP);
		a22=-a21;
		b1=(TM_PRCS*1000.0*tmp_r2)/C2;

		tmp_r1=cycle;
		tmp_r2=(N_STP_INI/(TM_PRCS*cycle));
		tmp_i1=tmp_r2;
		h_n0=(tmp_i1 < 1)? 1:tmp_i1;

		ip_pd1=CUR_CP_PD1*0.000001;//[A]APDɂ鐳o͓dlB
		in_pd1=-RTO_B_A_PD1*CUR_CP_PD1*0.000001;//[A]APDɂ镉o͓dlB
		ip_fd=CUR_CP_FD*0.000001;//[A]AFDɂ鐳o͓dlB
		in_fd=-RTO_B_A_FD*CUR_CP_FD*0.000001;//[A]AFDɂ镉o͓dlB
		im_fd=OFS_CUR_CP_FD*0.000001;//[A]AFDɂ钆ԃxo͓dliz͗jB
		rl_x1=0;
		rl_x2=0;

		tmp32b_lmtH={8'h00, 24'h7F_FFFF};
		tmp32b_lmtL=~tmp32b_lmtH;

		K_RTOI_val=K_RTOI;
		$init_my_runge_kutta(rl_relerr,rl_abserr,a11,a12,a21,a22,h_n,h_n0,rl_x1,rl_x2,
		tmp32b_lmtH,tmp32b_lmtL,vout_BK,rst_rk_BK,rst,rst_rk,hit_min_h,K_RTOI_val,rl_b1_iin);
	end

	//`[W|v
	always @ (pd1p or fdp) begin
		if(pd1p==1'b1) i_pd1=ip_pd1;
		else i_pd1=in_pd1;

		if((fdp==1'b1) &(fdn==1'b0)) i_fd=ip_fd;
		else if((fdp==1'b0) &(fdn==1'b1)) i_fd=in_fd;
		else i_fd=im_fd;

		//QNb^p
		rl_iin=i_pd1-i_fd;
		rl_b1_iin=b1*rl_iin;
		rst_rk <= 1'b1;
	end

	//Low Pass Filter
	always #(cycle) begin
		$calc_my_runge_kutta();
		vout<=vout_BK;
		rst_rk<=rst_rk_BK;
	end

endmodule
