//H
//Revised on 14:19 05/09/03
//Evaluate peak to peak, rms jitter between ref-clock and 135deg(45deg+90deg)-vco-genclk.
//But we assume that peak jitter is within +/- 50psec(-90deg~+90deg)

module msjt(strt,ref_clk,gen_clk_m90);
	input strt,ref_clk,gen_clk_m90;		//gen_clk_m90 => vout45
	reg ref_clk_pr,gen_clk_m90pr;
	reg en_mj_tsh;

	integer cycle;
	integer ts_av,cnt_av,ts_avmj,tm_avmj,ts_90deg,ts_180deg;
	integer mj_err;
	integer flg_set_gen_clk_m90;//VCONbÑGbW1ƂȂAt@XNbÑGbW0ƂȂB
	integer flg_set_gen_clk_m90tsh;	//VCONbÑGbW1ƂȂAȊOVCOԂ0
								//ƂȂB
	integer cnt_try_av;
	integer mj_cnt,mj_avr,rslt_av;
	integer tsh_min_gen_clk,tsh_max_gen_clk;
	integer cnt_tsh;
	integer mj_pk_min,mj_pk_max;
	integer tmp_i1,tmp_i2;
	integer hit_jtrms,mj_rms2_i;
	real tmp_r1,tmp_r2,tmp_r3;

	parameter TM_PRCS=0.001;//[nsec]AԒPʁB
	parameter CYCLE_MJ=1;//sۂ̃XLbvB1/CYCLE_MJpxӖB
	parameter T_AVRG=500;//[nsec]AstrtL->H̃Wb^ϒl߂邽߂̎ԂwB 
	parameter T_AVMJ=3000;//[nsec]As[NWb^RMSWb^l߂邽߂̎ԂwB
	parameter TS_CLK=0.2;//[nsec]At@XNbN̎B
	
	initial begin
		gen_clk_m90pr=1'b0;	//1 clockOVCO Clockivout45j
		ref_clk_pr=1'b0;		//1 clockORef Clock
		en_mj_tsh=1'b0;		//VCO̔tOOFFɐݒistrt="H"ONƂj

		cycle=CYCLE_MJ;

		tmp_r1=T_AVRG/(TM_PRCS*cycle);
		ts_av=tmp_r1;		//Wb^ʂ̕ϒl߂ԁiintjB
		tmp_r1=T_AVMJ/(TM_PRCS*cycle);
		ts_avmj=tmp_r1;		//s[NWb^RMSWb^ʂ𑪒肷ԁiintjB
		tm_avmj=ts_avmj+ts_av;//rms & peak jitter̎ZoIiintjB

		flg_set_gen_clk_m90=0;
		flg_set_gen_clk_m90tsh=0;

		tmp_r1=TS_CLK*0.25/(TM_PRCS*cycle);
		ts_90deg=tmp_r1;		//90degɑԁiintjB
		ts_180deg=ts_90deg*2;//180degɑԁiintjB
		
		cnt_try_av=0;	//VCONbNƃt@XNbÑGbW180degԂŃ~[g񐔂JEgB
		tsh_min_gen_clk=ts_180deg;//VCO̍ŏliintjB
		tsh_max_gen_clk=ts_180deg;//VCO̍őliintjB
		cnt_av=0;			//ϑp̃JE^i#cycleɍXVjB
		cnt_tsh=0;			//VCO-ClockGbW̌oߎԂΏۂƂJE^B
		mj_cnt=0;			//jitter߂邽߂̃JE^B
		mj_avr=0;			//jitter̕ς߂邽߂̑aiintjB
		mj_rms2_i=0;			//jitterrms^2߂邽߂̕ϐiintjB
		mj_pk_min=0;			//jitterpeakŏl߂邽߂̕ϐiintjB
		mj_pk_max=0;			//jitterpeakől߂邽߂̕ϐiintjB
		hit_jtrms=0;			//jitterrms^2vZɎgpTv(int)B
	end

	always # (cycle) begin
		if(strt==1'b0)  cnt_av=0;
		else begin
			ref_clk_pr <= ref_clk;
			gen_clk_m90pr <= gen_clk_m90;

			if(cnt_av < ts_av) begin//Wb^ʂ̕ϒl𑪒B
				tmp_i1=flg_set_gen_clk_m90;
				if(tmp_i1==0) begin
					mj_cnt=0;
					flg_set_gen_clk_m90=(gen_clk_m90==gen_clk_m90pr)? 0:1;
				end else begin
					mj_cnt=mj_cnt+1;
					flg_set_gen_clk_m90=(ref_clk==ref_clk_pr)? 1:0;
					if((ref_clk != ref_clk_pr) && (mj_cnt <= ts_180deg)) begin
						mj_avr=mj_avr +(mj_cnt-ts_90deg);
						cnt_try_av=cnt_try_av+1;
					end
				end
				cnt_av=cnt_av+1;

			end else if(cnt_av == ts_av) begin//Wb^ʂ̕ϒlvZB
				if(cnt_try_av==0) begin
					$display("Did not lock... So quit now.");
					$stop;
				end else begin
					tmp_r1=mj_avr;
					tmp_r2=cnt_try_av;
					tmp_r3=tmp_r1/tmp_r2;
					rslt_av=tmp_r3;
				end
				cnt_av=cnt_av+1;

			end else if(cnt_av > tm_avmj)//肵ȂB
				cnt_av=tm_avmj+2;

			else begin//"cnt_av > ts_av" && "cnt_av <= tm_avmj"𖞂P[XWb^̃s[NlRMSl𑪒B
					  //VCOŐNbN̍ŏƍő唼𑪒B
				tmp_i1=flg_set_gen_clk_m90;
				if(tmp_i1==0) begin
					mj_cnt=0;
					flg_set_gen_clk_m90=(gen_clk_m90==gen_clk_m90pr)? 0:1;
				end else begin
					mj_cnt=mj_cnt+1;
					flg_set_gen_clk_m90=(ref_clk==ref_clk_pr)? 1:0;
					if((ref_clk != ref_clk_pr) && (mj_cnt <= ts_180deg)) begin
						mj_err=mj_cnt -ts_90deg -rslt_av;
						mj_rms2_i=mj_rms2_i +(mj_err*mj_err);
						mj_pk_min=(mj_err < mj_pk_min)? mj_err : mj_pk_min;
						mj_pk_max=(mj_err > mj_pk_max)? mj_err : mj_pk_max;

						hit_jtrms=hit_jtrms+1;
					end
				end

				flg_set_gen_clk_m90tsh=(gen_clk_m90==gen_clk_m90pr)? 0:1;
				if(flg_set_gen_clk_m90tsh==0) 
					cnt_tsh=(en_mj_tsh==1'b1)? (cnt_tsh+1) : 1;
									//VCOŐNbNJEgB
				else begin
					if(en_mj_tsh==1'b1) begin//VCOŐNbN̍ŏƍőXVB
						tsh_min_gen_clk=(cnt_tsh < tsh_min_gen_clk)? cnt_tsh : tsh_min_gen_clk;
						tsh_max_gen_clk=(cnt_tsh > tsh_max_gen_clk)? cnt_tsh : tsh_max_gen_clk;
					end else
						en_mj_tsh=1'b1;
					cnt_tsh=1;
				end
				cnt_av=cnt_av+1;
			end
		end				
	end		

endmodule
