//ʑEgoH
//Revised on 03:11 05/09/25
//pd1_outp,pd1_outn,fd_outp,fd_outn :: 1bit-data

module pfd(rst,datp,datn,ck0p,ck0n,ck45p,ck45n,ck90p,ck90n,
		ck135p,ck135n,pd1_outp,pd1_outn,fd_outp,fd_outn,vdd,vss);
	input rst,datp,datn,ck0p,ck0n,ck45p,ck45n,ck90p,ck90n,
		ck135p,ck135n;
	input vdd,vss;
	output pd1_outp, pd1_outn, fd_outp, fd_outn;
	wire pd1_outp, pd1_outn, fd_outp, fd_outn;
	wire dat,ck0,ck45,ck90,ck135;
	wire pd1_out;
	wire [1:0] fd_out1;

	assign dat=(datp==~datn)? datp : 1'b0;
	assign ck0=(ck0p==~ck0n)? ck0p : 1'b0;
	assign ck45=(ck45p==~ck45n)? ck45p : 1'b0;
	assign ck90=(ck90p==~ck90n)? ck90p : 1'b0;
	assign ck135=(ck135p==~ck135n)? ck135p : 1'b0;
	assign pd1_outp=pd1_out;//
	assign pd1_outn=~pd1_outp;//
	assign fd_outp=fd_out1[1];//
	assign fd_outn=fd_out1[0];//

	fd I1 (rst,dat,ck0,ck45,ck90,ck135,pd1_out,fd_out1);
endmodule

//go
module fd(rst,dat,ck0,ck45,ck90,ck135,pd1_out,fd_out);
	input rst,dat,ck0,ck45,ck90,ck135;
	output [1:0] fd_out;
	output pd1_out;
	reg [1:0] fd_out,tmp_2b;
	wire pd1_out,pd2_out;

	pd I1 (rst,dat,ck45,ck135,pd1_out);
	pd I2 (rst,dat,ck0,ck90,pd2_out);

	always @ (pd1_out or posedge rst) begin
		if(rst==1'b1)
			fd_out <= 2'b00;
		else begin
			if(pd1_out==1'b1)
				tmp_2b=(pd2_out==1'b1)? 2'b10 : 2'b11;
			else
				tmp_2b=(pd2_out==1'b1)? 2'b01 : 2'b11;
			fd_out <= tmp_2b;
		end
	end
endmodule

//ʑo
module pd(rst,dat,ck0,ck1,pd_out);
	input rst,dat,ck0,ck1;
	output pd_out;
	wire cki,ckq,pd_out;

	detff I1 (rst,dat,ck0,cki);
	detff I2 (rst,dat,ck1,ckq);
	detff_ngt I3 (rst,ckq,cki,pd_out);
endmodule

//tbvEtbvH
module detff(rst,dat,ck,out);
	input rst,dat,ck;
	output out;
	reg out,cki,ckq;

	always @ (ck or posedge rst) begin
		if(rst==1'b1)
			out <= 1'b0;
		else
			out <= dat;
	end
endmodule

//]^̃tbvEtbvH
module detff_ngt(rst,dat,ck,out);
	input rst,dat,ck;
	output out;
	reg out,tmp_1b;

	always @ (ck or posedge rst) begin
		if(rst==1'b1)
			out <= 1'b0;
		else begin
			tmp_1b = (ck==1'b1)? dat : ~dat;
			out <= tmp_1b;
		end
	end
endmodule
