//CDRHpeXgx`
//Revised on 01:29 05/11/23

`timescale 1ps / 1ps

`include "top.v"
`include "dat_gen.v"
`include "msjt.v"

module tb_top;
	reg rst, ref_clk;
	reg strt_msjt, ckgen;
	reg msjt_clk;
	reg msjt_clk2;
	wire out_p, out_n, ckgen45_p, ckgen45_n, dat_p, dat_n;
	wire vdd, vss;
	wire [23:0] clf_out;

	integer ts_refclk;
	integer mcd;
	integer tmp_i1,tmp_i2;
	real tmp_r1,tmp_r2;

	//gbvHitopjƑHimsjtjpp[^
	parameter TM_PRCS=0.001;//[nsec]AԒPʁB

	//gbvHitopjpp[^
	parameter K_RTOI=524288.0;//realϐintegerϐ֕ϊWB
	parameter TD_PD1=0.3;//[nsec], xԁBPDpB
	parameter TRF_PD1=0.1;//[nsec], E莞ԁBPDpB
	parameter K_DIV_PD1=20;//(TD+TRF)/K_DIVlTCN(cycle)ƂBPDpB
	parameter TD_FD=0.5;//[nsec], xԁBFDpB
	parameter TRF_FD=0.1;//[nsec], E莞ԁBFDpB
	parameter K_DIV_FD=20;//(TD+TRF)/K_DIVlTCN(cycle)ƂBFDpB
	parameter CUR_CP_PD1=125.0;//[uA]BCharge-Pump̓dlBPD1pB
	parameter RTO_B_A_PD1=1.0;	//Charge-Pumpł̋z݂Ɠfod̔䗦(Un-match̉ex)BPDpB
	parameter CUR_CP_FD=125.0;//[uA]BCharge-Pump̓dlBFDpB
	parameter RTO_B_A_FD=1.0;//Charge-Pumpł̋z݂Ɠfod̔䗦(Un-match̉ex)BFDpB
	parameter OFS_CUR_CP_FD=0.0;//[uA]Bԃx͂łCharge-Pump̓dlBFDpB
	parameter CP=50.0;//[pF]BLPFł̃LpV^litB^萔jB
	parameter C2=2.0;//[pF]BCharge-Pumpؑւ莞̃tB[hX[ɘapLpV^lBLPFŎgpB
	parameter RP=30.0;//[Ohm]BLPFł̒RlitB^萔jB
	parameter TS_RK_LPF=0.001;//[nsec]BQNb^̎BLPFpB
	parameter N_STP_INI_LPF=0.064;//[nsec]BQNb^vZ̃Xebv̏liLPFo͂̍XV̏ljB
	parameter RELERR_LPF=0.001;//e΃G[iQNb^vZjB
	parameter ABSERR_LPF=0.00001;//e΃G[iQNb^vZjB
	parameter CYCLE_VCO=1;//VCOł̏o͍XVԁi=TM_PRCS*CYCLE_VCOjB
	parameter THETA_INIT=0.0;//[rad]AVCOł̏ʑB

	//Himsjtjpp[^
	parameter CYCLE_MJ=1;//sۂ̃XLbvB1/CYCLE_MJpxӖB
	parameter T_AVRG=300;//[nsec]Astrt_msjtL->H̃Wb^ϒl߂邽߂̎ԂwB 
	parameter T_AVMJ=500;//[nsec]As[NWb^RMSWb^l߂邽߂̎ԂwB
	parameter TS_CLK=0.2;//[nsec]At@XNbN̎B	

	defparam I2.TM_PRCS=TM_PRCS;
	defparam I2.K_RTOI=K_RTOI;
	defparam I2.TD_PD1=TD_PD1;
	defparam I2.TRF_PD1=TRF_PD1;
	defparam I2.K_DIV_PD1=K_DIV_PD1;
	defparam I2.TD_FD=TD_FD;
	defparam I2.TRF_FD=TRF_FD;
	defparam I2.K_DIV_FD=K_DIV_FD;
	defparam I2.N_STP_INI_LPF=N_STP_INI_LPF;
	defparam I2.RELERR_LPF=RELERR_LPF;
	defparam I2.ABSERR_LPF=ABSERR_LPF;
	defparam I2.TS_RK_LPF=TS_RK_LPF;
	defparam I2.CUR_CP_PD1=CUR_CP_PD1;
	defparam I2.RTO_B_A_PD1=RTO_B_A_PD1;
	defparam I2.CUR_CP_FD=CUR_CP_FD;
	defparam I2.RTO_B_A_FD=RTO_B_A_FD;
	defparam I2.OFS_CUR_CP_FD=OFS_CUR_CP_FD;
	defparam I2.CP=CP;
	defparam I2.C2=C2;
	defparam I2.RP=RP;
	defparam I2.CYCLE_VCO=CYCLE_VCO;
	defparam I2.THETA_INIT=THETA_INIT;

	defparam I3.TM_PRCS=TM_PRCS;
	defparam I3.CYCLE_MJ=CYCLE_MJ;
	defparam I3.T_AVRG=T_AVRG;
	defparam I3.T_AVMJ=T_AVMJ;
	defparam I3.TS_CLK=TS_CLK;

//---lbgXg
	assign vdd=1'b1;
	assign vss=1'b0;
	assign ckgen45=(ckgen45_p==ckgen45_n)? 1'b0 : ckgen45_p;
	dat_gen I1 (rst,ref_clk,dat_p,dat_n);
	top I2 (rst, dat_p, dat_n, out_p, out_n, ckgen45_p, ckgen45_n, clf_out, vdd, vss);
	msjt I3 (strt_msjt, ref_clk, ckgen45);

	initial begin
		tmp_r1=TS_CLK/TM_PRCS;
		ts_refclk=tmp_r1;//̓f[^pt@XNbNB
		mcd=$fopen("rslt.dat");//ʏݗpt@C̎wB
		rst=1'b1;	//ZbgLB
		strt_msjt=1'b0;//薳B

		#100 rst=1'b0;//ZbgB
		#1200000 strt_msjt=1'b1;//LB
		#810000 begin
			$fdisplay(mcd, "Wb^---ϒlF%d",I3.rslt_av);
			$fdisplay(mcd, "Wb^---s[NlF%dAs[NlF%d"
										,I3.mj_pk_max, I3.mj_pk_min);
			tmp_r1=I3.mj_rms2_i;
			tmp_r2=I3.hit_jtrms;
			$fdisplay(mcd, "Wb^---RMŜQlF%g", (tmp_r1/tmp_r2));
			$fdisplay(mcd, "VCONbN---ŏlF%d, őlF%d", 
										I3.tsh_min_gen_clk, I3.tsh_max_gen_clk);
			$fdisplay(mcd, "QNb^vZŋe덷𖞑Ȃ񐔁F%d"
										,I2.I2.hit_min_h);
			$fclose(mcd);
			$finish;
		end

	end

	always begin//̓f[^pt@XNbN̐B
		ref_clk=1'b0; #(ts_refclk/2);
		ref_clk=1'b1; #(ts_refclk/2);
	end

	always begin//VCO`F[Hdlނ߂̃NbNB
		msjt_clk=1'b0; #500;
		msjt_clk=1'b1; #500;
	end

	always @ (msjt_clk) begin//VCO`F[H́ijdl̏݁B
		$fdisplay(mcd, "%d	%g",$time, I2.I3.vin_rl);//1sڂ͎ԁAQsڂVCÓB
	end

endmodule
