//VCO`F[H
//Revised on 01:23 05/09/14
//vin, vout0, vout45, vout90, vout135 :: signed-integer, 4bit-over + 20bit-core
`timescale 1ps / 1ps

module vco_chn(rst,vin,out0p,out0n,out45p,out45n,out90p,out90n,
				out135p,out135n,vdd,vss);
	input rst;
	input [23:0] vin;
	input vdd,vss;	
	output  out0p,out0n,out45p,out45n,out90p,out90n,out135p,out135n;
	reg  out0p,out0n,out45p,out45n,out90p,out90n,out135p,out135n;
	reg [31:0] tmp32b_1,tmp32b_2;
	reg [23:0] vin2, vin24b_lmtH, vin24b_lmtL;

	integer cycle;
	real tmp_r1, tmp_r2, PI2, theta, dlt_t;
	real tmp_r3a, tmp_r3b, tmp_r3c, tmp_r3d, tmp_r4a, tmp_r4b, tmp_r4c, tmp_r4d;
	real a0, a1, a2, a3, a4, frq, vin_rl;
	
	real K_RTOI_val,THETA_INIT_val;

	parameter TM_PRCS=0.001;//[nsec]AԒPʁB
	parameter CYCLE_VCO=1;//VCOł̏o͍XVԂTM_PRCS*CYCLE_VCOŗ^B
	parameter THETA_INIT=0.0;//[rad]AʑB
	parameter K_RTOI=524288.0;	//lƓvZplƕϊ䗦B 
								//2^20ɑ΂āA2.0ΉB
	initial begin
		PI2 = 6.28318530717958647692528676655901;
		theta=THETA_INIT;
		dlt_t=TM_PRCS*CYCLE_VCO;
		cycle=CYCLE_VCO;

		vin24b_lmtH=24'h0E_6666;
		vin24b_lmtL=24'h00_0000;

		a0=4.6984;//a0`a4F4ߎ̌WB
		a1=0.2565;
		a2=-0.9054;
		a3=1.6146;
		a4=-0.548;

		THETA_INIT_val=THETA_INIT;
		K_RTOI_val=K_RTOI;
		$init_my_vco(theta,dlt_t,vin24b_lmtH,vin24b_lmtL,
		a0,a1,a2,a3,a4,THETA_INIT_val,K_RTOI_val,rst,vin,out0p,out45p,out90p,out135p,vin_rl);//VCO VPI[`
	end

	always #(cycle) begin
			$calc_my_vco();//VCO VPI CALL
			out0n = ~out0p;
			out45n = ~out45p;
			out90n = ~out90p;
			out135n = ~out135p;
		
	end

endmodule
